<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item label="订单上户日期" prop="inDate">
        <el-date-picker
          v-model="formData.inDate"
          type="date"
          value-format="x"
          placeholder="选择订单上户日期"
        />
      </el-form-item>
      <el-form-item label="订单下户日期" prop="outDate">
        <el-date-picker
          v-model="formData.outDate"
          type="date"
          value-format="x"
          placeholder="选择订单下户日期"
        />
      </el-form-item>
      <el-form-item label="订单价格" prop="price">
        <el-input v-model="formData.price" placeholder="请输入订单价格" />
      </el-form-item>
      <el-form-item label="订单城市" prop="city">
        <el-input v-model="formData.city" placeholder="请输入订单城市" />
      </el-form-item>
      <el-form-item label="合同id" prop="contractId">
        <el-input v-model="formData.contractId" placeholder="请输入合同id" />
      </el-form-item>
      <el-form-item label="需求id" prop="requestId">
        <el-input v-model="formData.requestId" placeholder="请输入需求id" />
      </el-form-item>
      <el-form-item label="月嫂id" prop="yuesaoId">
        <el-input v-model="formData.yuesaoId" placeholder="请输入月嫂id" />
      </el-form-item>
      <el-form-item label="用户id" prop="userId">
        <el-input v-model="formData.userId" placeholder="请输入用户id" />
      </el-form-item>
      <el-form-item label="订单状态 0=待签约 1=待上户 2=已上户 3=已完成 4=已取消 5=待审核" prop="status">
        <el-radio-group v-model="formData.status">
          <el-radio label="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="定金状态 0是未支付 1是支付成功 2是支付失败 3是定金已退款" prop="dingjinStatus">
        <el-radio-group v-model="formData.dingjinStatus">
          <el-radio label="1">请选择字典生成</el-radio>
        </el-radio-group>
      </el-form-item>
      <el-form-item label="定金数额" prop="dingjinMount">
        <el-input v-model="formData.dingjinMount" placeholder="请输入定金数额" />
      </el-form-item>
      <el-form-item label="订单评价" prop="comment">
        <el-input v-model="formData.comment" placeholder="请输入订单评价" />
      </el-form-item>
      <el-form-item label="补充条款" prop="supplement">
        <el-input v-model="formData.supplement" placeholder="请输入补充条款" />
      </el-form-item>
      <el-form-item label="签单时间" prop="signTime">
        <el-date-picker
          v-model="formData.signTime"
          type="date"
          value-format="x"
          placeholder="选择签单时间"
        />
      </el-form-item>
      <el-form-item label="false是不使用平台交付订单，true表示使用平台交付订单" prop="dingjinIsPlatform">
        <el-input v-model="formData.dingjinIsPlatform" placeholder="请输入false是不使用平台交付订单，true表示使用平台交付订单" />
      </el-form-item>
      <el-form-item label="退款时间" prop="refundTime">
        <el-date-picker
          v-model="formData.refundTime"
          type="date"
          value-format="x"
          placeholder="选择退款时间"
        />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">确 定</el-button>
      <el-button @click="dialogVisible = false">取 消</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import * as OrderApi from '@/api/order'

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  inDate: undefined,
  outDate: undefined,
  price: undefined,
  city: undefined,
  contractId: undefined,
  requestId: undefined,
  yuesaoId: undefined,
  userId: undefined,
  status: undefined,
  dingjinStatus: undefined,
  dingjinMount: undefined,
  comment: undefined,
  supplement: undefined,
  signTime: undefined,
  dingjinIsPlatform: undefined,
  refundTime: undefined
})
const formRules = reactive({
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await OrderApi.getOrder(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  if (!formRef) return
  const valid = await formRef.value.validate()
  if (!valid) return
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as OrderApi.OrderVO
    if (formType.value === 'create') {
      await OrderApi.createOrder(data)
      message.success(t('common.createSuccess'))
    } else {
      await OrderApi.updateOrder(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    inDate: undefined,
    outDate: undefined,
    price: undefined,
    city: undefined,
    contractId: undefined,
    requestId: undefined,
    yuesaoId: undefined,
    userId: undefined,
    status: undefined,
    dingjinStatus: undefined,
    dingjinMount: undefined,
    comment: undefined,
    supplement: undefined,
    signTime: undefined,
    dingjinIsPlatform: undefined,
    refundTime: undefined
  }
  formRef.value?.resetFields()
}
</script>
